image: docker:18-git
stages:
  - build
  - release

variables:
  DOCKER_HOST: tcp://docker:2375
  DOCKER_DRIVER: overlay2

.build_variables: &build_variables
  CONTAINER_NAME: ${CI_REGISTRY_IMAGE}:${CI_COMMIT_REF_SLUG}-${TERRAFORM_VERSION}-${ANSIBLE_VERSION}

.build_template: &build_template
  services:
    - docker:18-dind
  image: docker:18-git
  stage: build
  before_script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  stage: build
  script:
    - docker build --pull --build-arg terraform_version=${TERRAFORM_VERSION} --build-arg ansible_version=${ANSIBLE_VERSION} -t ${CONTAINER_NAME} "."
    - docker push ${CONTAINER_NAME}

terraform-v-ansible-v:
  <<: [*build_template]
  variables:
    TERRAFORM_VERSION: "1.2.0"
    ANSIBLE_VERSION: "4.10.0"
    <<: *build_variables
